.. This (-*- rst -*-) format file contains commonly used link targets
   and name substitutions.  It may be included in many files,
   therefore it should only contain link targets and name
   substitutions.  Try grepping for "^\.\. _" to find plausible
   candidates for this list.

.. NOTE: reST targets are
   __not_case_sensitive__, so only one target definition is needed for
   nipy, NIPY, Nipy, etc...

.. _nipy: http://nipy.org
.. _`Brain Imaging Center`: http://bic.berkeley.edu/
.. _dipy: http://dipy.org
.. _`dipy github`: http://github.com/nipy/dipy
.. _dipy pypi: http://pypi.python.org/pypi/dipy
.. _nipy issues: http://github.com/nipy/nipy/issues
.. _dipy issues: http://github.com/nipy/dipy/issues
.. _nibabel: http://nipy.org/nibabel
.. _nibabel pypi: http://pypi.python.org/pypi/nibabel
.. _nipy development guidelines: http://nipy.org/devel
.. _buildbots: http://nipy.bic.berkeley.edu/builders

.. Packaging
.. _neurodebian: http://neuro.debian.net
.. _neurodebian how to: http://neuro.debian.net/#how-to-use-this-repository
.. _pip: http://www.pip-installer.org/en/latest/
.. _easy_install: https://pypi.python.org/pypi/setuptools

.. Documentation tools
.. _graphviz: http://www.graphviz.org/
.. _Sphinx: http://sphinx.pocoo.org/
.. _`Sphinx reST`: http://sphinx.pocoo.org/rest.html
.. _reST: http://docutils.sourceforge.net/rst.html
.. _docutils: http://docutils.sourceforge.net

.. Licenses
.. _GPL: http://www.gnu.org/licenses/gpl.html
.. _BSD: http://www.opensource.org/licenses/bsd-license.php
.. _LGPL: http://www.gnu.org/copyleft/lesser.html

.. Working process
.. _pynifti: http://niftilib.sourceforge.net/pynifti/
.. _nifticlibs: http://nifti.nimh.nih.gov
.. _nifti: http://nifti.nimh.nih.gov
.. _`nipy launchpad`: https://launchpad.net/nipy
.. _launchpad: https://launchpad.net/
.. _`nipy trunk`: https://code.launchpad.net/~nipy-developers/nipy/trunk
.. _`nipy mailing list`: http://projects.scipy.org/mailman/listinfo/nipy-devel
.. _`nipy bugs`: https://bugs.launchpad.net/nipy
.. _pep8: http://www.python.org/dev/peps/pep-0008/
.. _`numpy coding style`: http://scipy.org/scipy/numpy/wiki/CodingStyleGuidelines
.. _python module path: http://docs.python.org/tutorial/modules.html#the-module-search-path

.. Code support stuff
.. _pychecker: http://pychecker.sourceforge.net/
.. _pylint: http://www.logilab.org/project/pylint
.. _pyflakes: http://divmod.org/trac/wiki/DivmodPyflakes
.. _virtualenv: http://pypi.python.org/pypi/virtualenv
.. _git: http://git.or.cz/
.. _github: http://github.com
.. _flymake: http://flymake.sourceforge.net/
.. _rope: http://rope.sourceforge.net/
.. _pymacs: http://pymacs.progiciels-bpi.ca/pymacs.html
.. _ropemacs: http://rope.sourceforge.net/ropemacs.html
.. _ECB: http://ecb.sourceforge.net/
.. _emacs_python_mode: http://www.emacswiki.org/cgi-bin/wiki/PythonMode
.. _doctest-mode: http://www.cis.upenn.edu/~edloper/projects/doctestmode/
.. _bazaar: http://bazaar-vcs.org/
.. _nose: http://somethingaboutorange.com/mrl/projects/nose
.. _`python coverage tester`: http://nedbatchelder.com/code/modules/coverage.html
.. _cython: http://cython.org

.. Other python projects
.. _numpy: http://numpy.scipy.org
.. _scipy: http://www.scipy.org
.. _ipython: http://ipython.scipy.org
.. _`ipython manual`: http://ipython.scipy.org/doc/manual/html
.. _matplotlib: http://matplotlib.sourceforge.net
.. _pythonxy: http://www.pythonxy.com
.. _ETS: http://code.enthought.com/projects/tool-suite.php
.. _`Enthought Tool Suite`: http://code.enthought.com/projects/tool-suite.php
.. _canopy: https://www.enthought.com/products/canopy
.. _anaconda: http://continuum.io/downloads
.. _python: http://www.python.org
.. _mayavi: http://mayavi.sourceforge.net/
.. _sympy: http://code.google.com/p/sympy/
.. _networkx: http://networkx.lanl.gov/
.. _setuptools: http://pypi.python.org/pypi/setuptools
.. _distribute: http://packages.python.org/distribute
.. _datapkg: http://okfn.org/projects/datapkg
.. _pytables: http://www.pytables.org
.. _python-vtk: http://www.vtk.org

.. Python imaging projects
.. _PyMVPA: http://www.pymvpa.org
.. _BrainVISA: http://brainvisa.info
.. _anatomist: http://brainvisa.info
.. _pydicom: http://code.google.com/p/pydicom/

.. Not so python imaging projects
.. _matlab: http://www.mathworks.com
.. _spm: http://www.fil.ion.ucl.ac.uk/spm
.. _spm8: http://www.fil.ion.ucl.ac.uk/spm/software/spm8
.. _eeglab: http://sccn.ucsd.edu/eeglab
.. _AFNI: http://afni.nimh.nih.gov/afni
.. _FSL: http://www.fmrib.ox.ac.uk/fsl
.. _FreeSurfer: http://surfer.nmr.mgh.harvard.edu
.. _voxbo: http://www.voxbo.org
.. _mricron: http://www.mccauslandcenter.sc.edu/mricro/mricron/index.html
.. _slicer: http://www.slicer.org/
.. _fibernavigator: https://github.com/scilus/fibernavigator

.. File formats
.. _DICOM: http://medical.nema.org/
.. _`wikipedia DICOM`: http://en.wikipedia.org/wiki/Digital_Imaging_and_Communications_in_Medicine
.. _GDCM: http://sourceforge.net/apps/mediawiki/gdcm
.. _`DICOM specs`: ftp://medical.nema.org/medical/dicom/2009/
.. _`DICOM object definitions`: ftp://medical.nema.org/medical/dicom/2009/09_03pu3.pdf
.. _dcm2nii: http://www.cabiatl.com/mricro/mricron/dcm2nii.html
.. _`mricron install`: http://www.cabiatl.com/mricro/mricron/install.html
.. _dicom2nrrd: http://www.slicer.org/slicerWiki/index.php/Modules:DicomToNRRD-3.4
.. _Nrrd: http://teem.sourceforge.net/nrrd/format.html

.. General software
.. _gcc: http://gcc.gnu.org
.. _xcode: http://developer.apple.com/TOOLS/xcode
.. _mingw: http://www.mingw.org/wiki/Getting_Started
.. _mingw distutils bug: http://bugs.python.org/issue2698
.. _cygwin: http://cygwin.com
.. _macports: http://www.macports.org/
.. _VTK: http://www.vtk.org/
.. _ITK: http://www.itk.org/
.. _swig: http://www.swig.org

.. Windows development
.. _mingw: http://www.mingw.org/wiki/Getting_Started
.. _msys: http://www.mingw.org/wiki/MSYS
.. _powershell: http://www.microsoft.com/powershell
.. _msysgit: http://code.google.com/p/msysgit
.. _putty: http://www.chiark.greenend.org.uk/~sgtatham/putty

.. Functional imaging labs
.. _`functional imaging laboratory`: http://www.fil.ion.ucl.ac.uk
.. _FMRIB: http://www.fmrib.ox.ac.uk

.. Other organizations
.. _enthought: <http://www.enthought.com>
.. _kitware: http://www.kitware.com
.. _nitrc: http://www.nitrc.org

.. General information links
.. _`wikipedia FMRI`: http://en.wikipedia.org/wiki/Functional_magnetic_resonance_imaging
.. _`wikipedia PET`: http://en.wikipedia.org/wiki/Positron_emission_tomography

.. Mathematical methods
.. _`wikipedia ICA`: http://en.wikipedia.org/wiki/Independent_component_analysis
.. _`wikipedia PCA`: http://en.wikipedia.org/wiki/Principal_component_analysis

.. Mathematical ideas
.. _`wikipedia spherical coordinate system`: http://en.wikipedia.org/wiki/Spherical_coordinate_system
.. _`mathworld spherical coordinate system`: http://mathworld.wolfram.com/SphericalCoordinates.html
.. _`wikipedia affine`: http://en.wikipedia.org/wiki/Affine_transformation
.. _`wikipedia linear transform`: http://en.wikipedia.org/wiki/Linear_transformation
.. _`wikipedia rotation matrix`: http://en.wikipedia.org/wiki/Rotation_matrix
.. _`wikipedia homogenous coordinates`: http://en.wikipedia.org/wiki/Homogeneous_coordinates
.. _`wikipedia axis angle`: http://en.wikipedia.org/wiki/Axis_angle
.. _`wikipedia Euler angles`: http://en.wikipedia.org/wiki/Euler_angles
.. _`Mathworld Euler angles`: http://mathworld.wolfram.com/EulerAngles.html
.. _`wikipedia quaternion`: http://en.wikipedia.org/wiki/Quaternion
.. _`wikipedia shear matrix`: http://en.wikipedia.org/wiki/Shear_matrix
.. _`wikipedia reflection`: http://en.wikipedia.org/wiki/Reflection_(mathematics)
.. _`wikipedia direction cosine`: http://en.wikipedia.org/wiki/Direction_cosine

.. vim:syntax=rst
